unit xmlrpc_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,
  // http interface
  WinInet,
  // lib for communicating xml-rpc
  xmlrpclib;

type
  TMainForm = class(TForm)
    Create: TButton;
    Memo1: TMemo;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    Edit2: TEdit;
    Edit3: TEdit;
    Memo2: TMemo;
    Send: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    procedure CreateClick(Sender: TObject);
    procedure SendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    Server: TXMLRPC;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Server := TXMLRPC.Create;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  Server.Free;
end;

procedure TMainForm.CreateClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  Memo1.Lines.Append( '<?xml version="1.0"?>' );
  Memo1.Lines.Append( '<methodCall>' );
  Memo1.Lines.Append( '<methodName>' + ComboBox1.Text + '</methodName>' );
  Memo1.Lines.Append( '<params>' );
  Memo1.Lines.Append( '</params>' );
  Memo1.Lines.Append( '</methodCall>' );
end;

procedure TMainForm.SendClick(Sender: TObject);
var
  Received: string;
begin
  Server.HostName := Edit2.Text;
  Server.Port := StrToInt( Edit3.Text );
  Server.UserName := Edit4.Text;
  Server.Password := Edit5.Text;
  Server.Execute( Edit1.Text, Memo1.Lines.Text, Received );
  Memo2.Lines.Clear;
  // format the returned xml nicely for showing in Memo object
  Memo2.Lines.Text := StringReplace( Received, #10, #13#10, [ rfReplaceAll, rfIgnoreCase ] );
end;

end.
