unit xmlrpclib;

interface

uses
  Windows;

type
  TXMLRPC = class( TObject )
    private
      FPort: Integer;
      FHostName,
      FAgent,
      FUserName,
      FPassword,
      FSend,               // the query which will be send
      FObject,             // the object of file on the remote server the request is directed to
      FReceived: string;   // the answer returned by the remote object (or server)
    public
      procedure Execute( sObject, sSend: string; var sReceived: string );
      property Send: string read FSend write FSend;
      property TheObject: string read FObject write FObject;
      property Received: string read FReceived write FReceived;
      property Port: Integer read FPort write FPort;
      property HostName: string read FHostName write FHostName;
      property Agent: string read FAgent write FAgent;
      property UserName: string read FUserName write FUserName;
      property Password: string read FPassword write FPassword;
    end;

implementation

uses
  Wininet;

procedure TXMLRPC.Execute( sObject, sSend: string; var sReceived: string );
var
  hSession, hConnect, hRequest: hInternet;
  Buf: Pointer;
  Data: Array[ 0..$400 ] of Char;
  AcceptType: LPStr;
  sTmp: String;
  dwBufLen,
  dwIndex,
  dwBytesToRead,
  dwBytesRead: DWord;
begin
  // init vars
  hSession := nil; hConnect := nil; hRequest := nil; buf := nil;
  // save params for reference
  FSend := sSend;
  FObject := sObject;
  // send the request
  AcceptType := PChar( '*/*' );
  try
    hSession := InternetOpen( PChar( FAgent), INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0 );
    hConnect := InternetConnect( hSession, PChar( FHostName ), FPort, PChar( FUserName ), PChar( FPassword ), INTERNET_SERVICE_HTTP, 0, 0 );
    hRequest := HttpOpenRequest( hConnect, 'POST', PChar( FObject ), 'HTTP/1.0', PChar( '' ), @AcceptType, INTERNET_FLAG_RELOAD, 0);
    HttpSendRequest( hRequest, 'Content-Type: text/xml', 22, PChar( FSend ), Length( FSend ) );

    dwIndex  := 0;
    dwBufLen := 1024;
    GetMem( Buf, dwBufLen );
    if HttpQueryInfo( hRequest, HTTP_QUERY_CONTENT_LENGTH, Buf, dwBufLen, dwIndex ) then begin
      dwBytesRead := 0;
      FReceived := '';
      while True do begin
        if not InternetReadFile( hRequest, @Data, SizeOf( Data ), dwBytesToRead ) then
          Break
        else begin
          if dwBytesToRead = 0 then
            Break
          else begin
            sTmp := Data;
            SetLength( sTmp, dwBytesToRead );
            FReceived := FReceived + sTmp;
            Inc( dwBytesRead, dwBytesToRead );
          end;
        end;
      end;
      SetLength( FReceived, dwBytesRead );
    end;

  finally
    FreeMem( Buf );
    InternetCloseHandle( hRequest );
    InternetCloseHandle( hConnect );
    InternetCloseHandle( hSession );
  end;
  sReceived := FReceived;
end;

end.
